local BattleFuncSet = false

addHook("ThinkFrame",function()
	if (BattleFuncSet) or not(CBW_Battle and CBW_Battle.SkinVars) then return end
		BattleFuncSet = true
		local StefanPriority = function(player)
			if player.mo.magentathok
				CBW_Battle.SetPriority(player,1,0,nil,1,0,"Magenta Thok")
			end
			if player.mo.stefanboost
				if FixedHypot(player.rmomx, player.rmomy) >= stfnspeed(player)
					CBW_Battle.SetPriority(player,1,2,nil,1,2,"Stefan Boost")
				end
			end
		end
		local StefanExhaust = function(player)
			if player.mo.stfnslowfall == 1
				if not player.prevhover
					player.exhaustmeter = max(0,$-FRACUNIT/20)
				end
				player.prevhover = true
				local maxtime = 3*TICRATE
				player.exhaustmeter = max(0,$-FRACUNIT/maxtime)
				if player.exhaustmeter <= 0
					player.mo.stfnslowfall = 0
					player.mo.state = S_PLAY_FALL
				end
				return true
			else
				player.prevhover = false
			end
		end
		local StefanBattle = function(mo,doaction,pressedaction)
		local player = mo.player
		if mo.dashfly or mo.magentathok or mo.stfnslowfall or mo.stefanboost or mo.stefancheckdamage or player.homing or mo.stefanfuck
			player.canguard = false
		end
		if P_IsObjectOnGround(mo)
			player.actiontext = "Stefan Boost"
			player.actionrings = 10
		else
			if P_LookForEnemies(player)
			and not P_IsObjectOnGround(mo)
			and (player.pflags & PF_JUMPED)
				player.actiontext = "Homing Attack"
			else
				player.actiontext = "Magenta Shot"
				player.actionrings = 10
			end
		end
		if player.actionstate != 0
			player.canguard = false
		end
		if player.actionstate == 0
		and not mo.magentathok
		and not mo.stefanboost
		and not P_LookForEnemies(player)
			if doaction == 1
				if P_IsObjectOnGround(mo)
					S_StartSound(mo, sfx_s3k78)
					mo.stefanboost = 35
					mo.dashfly = 0
					mo.stfnslowfall = 0
					S_StartSound(mo, sfx_s231)
					CBW_Battle.PayRings(player)
					CBW_Battle.ApplyCooldown(player,TICRATE*5)
				else
					mo.dashfly = 0
					mo.stfnslowfall = 0
					S_StartSound(mo, sfx_tblr)
					mo.state = S_PLAY_FALL
					if (mo.eflags & MFE_UNDERWATER)
						P_SetObjectMomZ(mo, 9*FRACUNIT/2, false)
						P_InstaThrust(mo, player.drawangle, -8*FRACUNIT/2)
					else
						P_SetObjectMomZ(mo, 9*FRACUNIT, false)
						P_InstaThrust(mo, player.drawangle, -8*FRACUNIT)
					end
					P_SPMAngle(mo, MT_MGNTATTACK, player.drawangle, 0)
					local scarfshot1 = P_SPMAngle(mo, MT_MGNTATTACK, player.drawangle-ANG2, 0)
					local scarfshot2 = P_SPMAngle(mo, MT_MGNTATTACK, player.drawangle+ANG2, 0)
					CBW_Battle.PayRings(player)
					CBW_Battle.ApplyCooldown(player,TICRATE*5)
				end
			end
		end
	end
	CBW_Battle.SkinVars["stefan"] = {
		weight = 100,
		special = StefanBattle,
		func_exhaust = StefanExhaust,
		func_priority_ext = StefanPriority
	}
	print("Stefan the Fox Battle Mode support has been added!")
end)